% Derivazione di consistenza

% definizione di consistency
ask_consistency(Bunch, Delta, DeltaIn, DeltaOut):-
	println(['ask_consistency(',Bunch,Delta,DeltaIn,DeltaOut,')']), nl,
	no_conflicts(Delta,DeltaIn),
	ask_agents_abd(Bunch, Delta, DeltaIn, DeltaOutList),
	println(['ask_agent_abd risultato: DeltaOutList = (',DeltaOutList,')']), nl,	
	agree(Bunch, Delta, DeltaOutList, DeltaIn, DeltaOut).

ask_consistency(_,no,_,no).	

% Devo terminare se Delta1 e Delta2 hanno gli stessi elem (anche in posiz diverse)
agree(_, Delta1, Delta2, _, Delta2):-
	uguali(Delta1,Delta2),
	println(['agree: termination']), nl.

agree(Bunch, Delta, DeltaOutList, DeltaIn, DeltaOut):-
	not(uguali(Delta,DeltaOutList)),
	println(['agree(',Bunch,_,DeltaOutList,DeltaIn,DeltaOut,')']), nl,
	ask_consistency(Bunch, DeltaOutList, DeltaIn, DeltaOut).
	

% termination
ask_agents_abd([], _, _, []):-
	println(['ask_agent_abd: termination']), nl.

ask_agents_abd([Agent|Tail], Delta, DeltaIn, DeltaOut):-
	println(['ask_agent_abd(',[Agent|Tail],Delta,DeltaIn,DeltaOut,')']), nl,
	ask_remote_abd(Agent, Delta, DeltaIn, AgentDeltaOut), % AgentDeltaOut  un superset di Delta e DeltaIn
	ask_agents_abd(Tail, AgentDeltaOut, DeltaIn, TailDeltaOut),
	union(AgentDeltaOut,TailDeltaOut,DeltaOut).


ask_remote_abd(Agent,Delta,DeltaIn,DeltaOut):-
	println(['ask_remote_abd(',Agent,Delta,DeltaIn,DeltaOut,')']), nl,
	agent(Agent, Host, Port),
	% set_host(Host), prob in locale
	set_that_port(Port),
	there,
	out(laila_query(Agent, down(Delta), DeltaIn)),
	in(answer(Agent, down(Delta), DeltaIn, DeltaOut)),
	println(['ask_remote_abd: DeltaOut = (',DeltaOut,')']), nl.

no_conflicts(_,no). % serve per non far fallire il controllo dopo la collaborazione se ho un no
no_conflicts(ListIn, ListOut):-
	not(eq(ListOut,no)),
	union(ListIn, ListOut, ListTot),
	no_conflicts(ListTot). 


no_conflicts([]).
no_conflicts([Head|Tail]):-
	negate(Head, NegHead),
	not(member(NegHead, Tail)),
	no_conflicts(Tail).

%unione di insiemi (devo quindi prima eliminare i ripetuti nelle liste).
union(L1,L2,L):- 
	elim_rip(L1,S1),
	elim_rip(L2,S2),
	uni(S1,S2,L).


elim_rip([],[]).
elim_rip([X|REST],S):-
	member(X,REST),
	elim_rip(REST,S).
elim_rip([X|REST],[X|S]):-
	not(member(X,REST)),
	elim_rip(REST,S).	


uni([], L2, L2).
uni([X|REST], L2, L):-
	member(X, L2),
	uni(REST, L2, L).
uni([X|REST], L2, [X|L]):-
	not(member(X, L2)),
	uni(REST, L2, L).

% mi dice se due insiemi sono uguali (devo quindi prima eliminare i ripetuti nelle liste).
uguali(L1,L2):-
	elim_rip(L1,S1),
	elim_rip(L2,S2),
	ug(S1,S2),
	ug(S2,S1).


ug([],_).
ug([X|REST],S):-
	member(X,S),
	ug(REST,S).



